"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Form = void 0;
var react_1 = __importStar(require("react"));
var FormsContext_1 = require("./FormsContext");
exports.Form = function (_a) {
    var children = _a.children, id = _a.id;
    var _b = react_1.useContext(FormsContext_1.FormsContext), formsById = _b.formsById, _mountForm = _b._mountForm, _unmountForm = _b._unmountForm;
    // an effect to insert/remove a form into the FormsContext.formsById hash-map
    react_1.useEffect(function () {
        if (id in formsById === false) {
            _mountForm(id);
        }
        return function () {
            _unmountForm(id);
        };
    }, []);
    return react_1.default.createElement(react_1.default.Fragment, null, children);
};
